#!/usr/bin/perl -w

# Banword. Ver 0.2.  
# This is a perl script for xchat by cancan@evhr.net
# Put the script in your ~/.xchat directory and it will be automatically loaded

# This script adds the commands:
# /helpwd     : script help
# /listwd     : list your current banword file
# /addwd      : add a banword, you must give the channel (without the #) and the word
# /delwd      : delete a banword, you must give the channel (without the #) and the word
# /savewd     : save the banword list in ~/.xchat/.banword

IRC::add_message_handler("PRIVMSG", "kickword");
IRC::add_command_handler("helpwd", "helpword");
IRC::add_command_handler("listwd", "listword");
IRC::add_command_handler("savewd", "saveword");
IRC::add_command_handler("addwd", "addword");
IRC::add_command_handler("delwd", "delword");

$homepathenv=$ENV{"HOME"};
$homepath="$homepathenv/.xchat/";
@kickwords=@nothing;

# Loading the banword file

if (open(BANWORD,$homepath.".banword")) {
  IRC::print "\002 Loading the Ban Word file\002\n";
  $list = "";
  $list = <BANWORD>;
  @kickwords = split('\n',$list);
  close(BANWORD);
}
else {
  IRC::print "\002 Ban Word File not found, maybe you haven't one ;o)\002\n";
}

sub listword
{
  IRC::print "\002 List of all the unauthorised words\002\n";
  IRC::print "\002------------------------------------\002\n";
 
  foreach $listword (@kickwords) {
    $listword =~ /(.*):::(.*):::/i;
    IRC::print " Channel : \002$1\002  unauthorised word : \002\0034$2\003\002\n";
  }
  return 1;
}

sub helpword
{
  IRC::print "\002 Commands are : \0034addwd\003  <channel> <word>\002\n";
  IRC::print "\002                               adds a unauthorise word to the channel\002\n";
  IRC::print "\002                \0034delwd\003  <channel> <word>\002\n";
  IRC::print "\002                               dels a unauthorise word to the channel\002\n";
  IRC::print "\002                \0034listwd\003  list the unautorised words\002\n";
  IRC::print "\002                \0034savewd\003  save the unautorised words\002\n";
  IRC::print "\002                \0034helpwd\003  this help text\002\n";
  return 1;
}

sub saveword
{
  if (!(open(BANWORD,">".$homepath.".banword"))) {
    IRC::print "\002 Couldn't open the Ban word file !!!!!!!!!!!\002\n";
  }
  else {
    foreach $lineec (@kickwords) {
      print BANWORD ("$lineec\n");
    }
    close(BANWORD);
    IRC::print "\002 Ban Word file saved\002\n";
    return 1;
  }
}

sub addword
{
  my $lineword = shift(@_);
  @newword = split(' ',$lineword);

  $newchanword = $newword[0];
  $newwordword = $newword[1];
  if (!($newchanword =~ /\S+/ && $newwordword =~ /\S+/ )) {
    IRC::print "\002 Enter channel and word, such as #linux billgates\002\n";
    return 1;
  }
  $mots2 = "#".$newchanword;
  $mots3 = " ".$newwordword." ";
  push @kickwords,($mots2.":::".$mots3.":::");
  IRC::print "\002 Word \0034$newwordword\003  added for channel \0034$mots2\003\002\n";
  return 1;
}

sub delword
{
  my $lineword = shift(@_);
  @newword = split(' ',$lineword);
  $newchanword = $newword[0];
  $newwordword = $newword[1];
  if (!($newchanword =~ /\S+/ && $newwordword =~ /\S+/ )) {
    IRC::print("\002 Enter channel and word, such as linux billgates\002");
    return 1;
  }
  $mots2 = "#".$newchanword;
  $mots3 = " ".$newwordword." ";

  @holdin="";
  pop(@holdin);
  unless (open(BANWORD, ">".$homepath.".banword")) {
    IRC::print("\002Couldn't open output file .banword!\002");
    return 1;
  }
  foreach $acompar (@kickwords){
    @testword = split(':::',$acompar);
    $testchanwd = $testword[0];
    $testwordwd = $testword[1];
    if (!($mots3 =~ $testwordwd && $testchanwd =~ $mots2)) {
      print BANWORD ("$acompar\n");
      push @holdin, $acompar;
    }
  }
  @kickwords = @holdin;
  close(BANWORD);
  IRC::print "\002 Word \0034$newwordword\003  deleted for channel \0034$newchanword\003\002\n";
}

sub kickword
{
  my $line = shift(@_);
  $line =~ /:(.*)!(\S+) PRIVMSG (.*) :(.*)/i;
  $motnick = $1;
  $motchan = $3;
  @mots = split(' ',$4);
  foreach $testmots (@mots) {
    $mots3 = " ".$testmots." ";
    foreach $acompar (@kickwords){
      @testword = split(':::',$acompar);
      $testchanwd = $testword[0];
      $testwordwd = $testword[1];
      if ($mots3 =~ $testwordwd && $testchanwd =~ $motchan) {
        $motkick = " Ban_Word : \002\0034".$testmots."\003\002";    
        IRC::command "/raw KICK $motchan $motnick $motkick\n";
        IRC::print "\002 KICK $motchan $motnick $motkick\002\n";
        return 1;
      }
    }
  }
  return 0;
}
